<?php

declare(strict_types=1);

namespace Pinpoint\SortByPrice\Plugin\Catalog\Block\Product\ProductList;

use Pinpoint\SortByPrice\Helper\Data;

class Toolbar
{
    public function aroundSetCollection(
        \Magento\Catalog\Block\Product\ProductList\Toolbar $subject,
        \Closure $proceed,
        \Magento\Framework\Data\Collection $collection
    ) {
        $order = $subject->getCurrentOrder();
        $result = $proceed($collection);

        if ($order === Data::HIGH_TO_LOW) {
            $subject->getCollection()->setOrder('price', 'desc');
        }

        if ($order === Data::LOW_TO_HIGH) {
            $subject->getCollection()->setOrder('price', 'asc');
        }

        return $result;
    }
}
